searchData={"items":[{"type":"behaviour","title":"AI","doc":"","ref":"AI.html"},{"type":"callback","title":"AI.get_embeddings/2","doc":"","ref":"AI.html#c:get_embeddings/2"},{"type":"callback","title":"AI.get_summary/3","doc":"","ref":"AI.html#c:get_summary/3"},{"type":"callback","title":"AI.new/0","doc":"","ref":"AI.html#c:new/0"},{"type":"module","title":"Fnord","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and search code files.","ref":"Fnord.html"},{"type":"function","title":"Fnord.main/1","doc":"","ref":"Fnord.html#main/1"},{"type":"function","title":"Fnord.parse_options/1","doc":"","ref":"Fnord.html#parse_options/1"},{"type":"module","title":"Git","doc":"","ref":"Git.html"},{"type":"function","title":"Git.is_ignored?/2","doc":"","ref":"Git.html#is_ignored?/2"},{"type":"module","title":"Indexing","doc":"","ref":"Indexing.html"},{"type":"function","title":"Indexing.delete_project/1","doc":"","ref":"Indexing.html#delete_project/1"},{"type":"function","title":"Indexing.new/3","doc":"","ref":"Indexing.html#new/3"},{"type":"function","title":"Indexing.run/2","doc":"","ref":"Indexing.html#run/2"},{"type":"module","title":"Queue","doc":"A module that implements a process pool using a GenServer.","ref":"Queue.html"},{"type":"function","title":"Queue.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Queue.html#child_spec/1"},{"type":"function","title":"Queue.init/1","doc":"","ref":"Queue.html#init/1"},{"type":"function","title":"Queue.join/1","doc":"Waits until the queue is empty and all workers have exited.","ref":"Queue.html#join/1"},{"type":"function","title":"Queue.map/2","doc":"Queues an Enum of jobs, executes them, and returns the results in order.","ref":"Queue.html#map/2"},{"type":"function","title":"Queue.queue/2","doc":"Adds a job to the queue and returns a Task.","ref":"Queue.html#queue/2"},{"type":"function","title":"Queue.shutdown/1","doc":"Shuts down the queue, preventing new jobs from being added.","ref":"Queue.html#shutdown/1"},{"type":"function","title":"Queue.start_link/2","doc":"Starts the Queue with the given callback function and maximum number of workers.\nReturns {:ok, pid}","ref":"Queue.html#start_link/2"},{"type":"module","title":"Scanner","doc":"The `Scanner` module traverses a directory recursively, skipping hidden files\nand files that should be ignored based on a `.gitignore` file. It also skips\nbinary files and files with a size of 0 bytes.","ref":"Scanner.html"},{"type":"function","title":"Scanner.new/2","doc":"","ref":"Scanner.html#new/2"},{"type":"function","title":"Scanner.scan/2","doc":"","ref":"Scanner.html#scan/2"},{"type":"module","title":"Search","doc":"","ref":"Search.html"},{"type":"function","title":"Search.run/1","doc":"","ref":"Search.html#run/1"},{"type":"module","title":"Store","doc":"","ref":"Store.html"},{"type":"function","title":"Store.cosine_similarity/2","doc":"","ref":"Store.html#cosine_similarity/2"},{"type":"function","title":"Store.delete_file/2","doc":"","ref":"Store.html#delete_file/2"},{"type":"function","title":"Store.delete_missing_files/2","doc":"","ref":"Store.html#delete_missing_files/2"},{"type":"function","title":"Store.delete_project/1","doc":"","ref":"Store.html#delete_project/1"},{"type":"function","title":"Store.get/2","doc":"","ref":"Store.html#get/2"},{"type":"function","title":"Store.get_embeddings/2","doc":"","ref":"Store.html#get_embeddings/2"},{"type":"function","title":"Store.get_hash/2","doc":"","ref":"Store.html#get_hash/2"},{"type":"function","title":"Store.get_summary/2","doc":"","ref":"Store.html#get_summary/2"},{"type":"function","title":"Store.home/0","doc":"","ref":"Store.html#home/0"},{"type":"function","title":"Store.info/2","doc":"","ref":"Store.html#info/2"},{"type":"function","title":"Store.list_files/1","doc":"","ref":"Store.html#list_files/1"},{"type":"function","title":"Store.list_projects/0","doc":"","ref":"Store.html#list_projects/0"},{"type":"function","title":"Store.new/1","doc":"","ref":"Store.html#new/1"},{"type":"function","title":"Store.put/5","doc":"","ref":"Store.html#put/5"},{"type":"module","title":"Summary","doc":"","ref":"Summary.html"},{"type":"function","title":"Summary.run/2","doc":"","ref":"Summary.html#run/2"},{"type":"extras","title":"Fnord","doc":"# Fnord\n\n[![Run tests](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\nFnord is a command line tool the builds a searchable database of your files,\nusing AI-generated embeddings to index and search your code base, notes, and\nother (non-binary) files.","ref":"readme.html"},{"type":"extras","title":"Installation - Fnord","doc":"1. Install `elixir` if necessary:\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n2. Add the mix escript path to your shell's PATH:\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n3. Install the script:\n```bash\nmix escript.install github sysread/fnord\n```\n\nUse the same command to reinstall. It will offer to overwrite the existing\ninstallation.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Fnord","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Indexing - Fnord","doc":"The first time you run this, especially on a large codebase, it will take a\nwhile to index everything. Subsequent runs will be faster, re-indexing only\nthose files which have changed since they were last indexed.\n\n```bash\nfnord index --project foo --dir /path/to/foo\n```\n\nYou can **reindex** the project, forcing it to reindex all files:\n\n```bash\nfnord index --project foo --dir /path/to/foo --reindex\n```","ref":"readme.html#indexing"},{"type":"extras","title":"Searching - Fnord","doc":"```bash\nfnord search --project foo --query \"some search query\"\n```\n\nIf you want more detail about each file matched:\n\n```bash\nfnord search --project foo --query \"some search query\" --detail\n```","ref":"readme.html#searching"},{"type":"extras","title":"Miscellaneous - Fnord","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files --project foo`\n- **Show the AI-generated summary of a file:** `fnord summary --project foo --file bar`\n- **Delete a project:** `fnord delete --project foo`\n\nNote that deleting a project only deletes from the index, not the actual files.","ref":"readme.html#miscellaneous"},{"type":"extras","title":"TODO - Fnord","doc":"- Better test coverage (don't judge me)\n- Optimize for use as a library\n    - Document APIs\n- Configurable concurrency limits (currently hard-coded at 4)\n- Daemon mode that watches for file changes and updates the index\n    - Handle deleted files\n- Progress bar","ref":"readme.html#todo"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}